#include <stdio.h>
#include "crc32.h"

//#define FAST_CRC32
#define SLOW_CRC32

#define CRC_INITIALVALUE 0xFFFFFFFF

extern unsigned long __checksum;

static unsigned short start_addr = 0x0080;
static unsigned short end_addr   = 0xFFFB;
#ifdef SLOW_CRC32
static const unsigned long zero=0;
#endif

int main(void)
{
unsigned long sum=0;


#ifdef FAST_CRC32
     sum = set_crc32_init_value (CRC_INITIALVALUE);
     sum = fast_crc32(sum, (unsigned char*)start_addr, 
                      end_addr - start_addr + 1);
#elif defined SLOW_CRC32
     sum = slow_crc32(CRC_INITIALVALUE, (unsigned char*)start_addr, 
                      end_addr - start_addr + 1);
     sum = slow_crc32(sum, (unsigned char *)&zero, 4);
#endif

     if(sum!=__checksum)
     {
          printf("Checksum failed: 0x%04lX (calculated) "
                 "vs 0x%04lX (from linker)\n", sum, __checksum);
     }
     else
     {
          printf("* Checksum 0x%04lX is correct! *\n", __checksum);
     }
}
